#ifndef LOCKMANAGER_H
#define LOCKMANAGER_H

#include <stdbool.h>
#include <stralloc.h>

typedef struct lockset* lockset[1];
typedef void (*lockhandler)(lockset set, char* lock_name, void* handle);

/* initialize lock set */
bool lm_init(lockset set);

/* release storage */
void lm_free(lockset set);

/* add user to the lock set */
bool lm_adduser(lockset set, char* user_name);

/* remove user and all his/her locks */
bool lm_removeuser(lockset set, char* user_name);

bool lm_stat(lockset set, char* lock_name, stralloc* holder);

typedef enum {LOCK_FAILED, LOCK_OK, LOCK_WAITING} lock_status;
lock_status lm_lock(lockset set, char* user_name, char* lock_name,
	            lockhandler handler, void* handle);

bool lm_release(lockset set, char* user_name, char* lock_name);

#endif
