#include <afblib/inbuf.h>
#include <afblib/inbuf_scan.h>
#include <afblib/outbuf.h>
#include <afblib/outbuf_printf.h>
#include "mxprequest.h"

/* read one request from the given session */
bool read_mxp_request(session* s, mxp_request* request) {
   return
      mpx_session_scan(s, &request->keyword, &request->parameter) == 2;
}

bool write_mxp_request(outbuf* obuf, mxp_request* request) {
   return
      outbuf_printf(obuf, "%.*s %.*s\r\n",
	 request->keyword.len, request->keyword.s,
	 request->parameter.len, request->parameter.s) > 0;
}

/* release resources associated with request */
void free_mxp_request(mxp_request* request) {
   stralloc_free(&request->keyword);
   stralloc_free(&request->parameter);
}
