#ifndef MXP_REQUEST_H
#define MXP_REQUEST_H

#include <stdbool.h>
#include <stralloc.h>
#include <afblib/mpx_session.h>
#include <afblib/outbuf.h>

#define MXP_REQUEST_RE "([a-z]+) (.*?)\r?\n"

typedef struct mxp_request {
   stralloc keyword;
   stralloc parameter;
} mxp_request;

/* read one request from the given session */
bool read_mxp_request(session* s, mxp_request* request);

/* write one request to the given outbuf */
bool write_mxp_request(outbuf* obuf, mxp_request* request);

/* release resources associated with request */
void free_mxp_request(mxp_request* request);

#endif
